
//Gia na mhn emfanizetai to console Window sthn arxh tou programmatos prepei na topoqeteitai to: 
#pragma comment( linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"" )

#include <glut.h>

GLint screenWidth= 640;
GLint screenHeight =480;

int menu; // for menu creation
int selection; // for menu choices
int sxhma; // for drawing line or rectangle

 typedef struct 
 { 
	 GLint x,y;
 }
 GLintPoint;


void drawPoint( int ax, int ay)
{
	glBegin(GL_POINTS);
		glVertex2i(ax,ay);
	glEnd();
	glFlush();
}

void drawLine(int ax, int ay, int bx, int by)
{
	glBegin(GL_LINES);
		glVertex2i(ax,ay);
		glVertex2i(bx, by);
	glEnd();
	glFlush();
}

void myInit (void)
{
	glClear(GL_COLOR_BUFFER_BIT);		// clear the screen
	glClearColor(0.0, 0.0, 0.0, 0.0);    // select clearing (background) color
	//glColor3f(1.0, 1.0, 1.0);           // initialize viewing color values
	glColor3f(0.0,0.0,1.0);
	glPointSize(4);						// set point size
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(0.0,(GLfloat)screenWidth, 0.0,(GLfloat)screenHeight);// Creates a matrix for projecting two dimensional
																	// coordinates onto the screen and multiplies the 
																	// current projection matrix by it.
																	// It is used for projecting a two dimensional image 
																	// onto a two dimensional screen. 
																	// For two dimensional objects using two dimensional 
																	// vertex commands all z coordinates are zero.
	glFlush();
}
										

void myDisplay(void)
{
	glClear(GL_COLOR_BUFFER_BIT);		// clear the screen

	glFlush();							// send all output to display
}

 //Specifying a rectangle with the mouse
void myMouse (int button, int state, int x1, int y1)
{
	static GLintPoint corner[2];
	static int numCorners =0;
	if (button == GLUT_LEFT_BUTTON && state ==GLUT_DOWN)
	{		
		corner[numCorners].x =x1;
		corner[numCorners].y = screenHeight-y1;
		drawPoint(corner[numCorners].x,corner[numCorners].y);
		numCorners++;
		if (numCorners == 2)
		{
			glColor3f(0.0,0.0,1.0);
		
			if(sxhma == 2)
			{
				
				glColor3f(1.0,0.0,0.0);
				
				glRecti(corner[0].x, corner[0].y, corner[1].x, corner[1].y);
			}
			if (sxhma == 1)
			{
				glColor3f(0.0,1.0, 0.0);
				drawLine(corner[0].x, corner[0].y, corner[1].x, corner[1].y);
			}
			numCorners =0;
		}
	}
		else if (button == GLUT_MIDDLE_BUTTON && state == GLUT_DOWN)
			glClear(GL_COLOR_BUFFER_BIT);  // clear the window
		
		glFlush();
	
}
	// triggered when a Keyboard key is pressed
void keyEvent(unsigned char key, int x, int y)
{
	switch (key)
	{
		//Quit
		case 'Q':
		case 'q':
		exit(-1);
		break;
		default:
		break;
	}
}

// Menu choices
void myMenu(int selection)
{
	if(selection==1) // drawing  line
	{
		sxhma=1;
		glutPostRedisplay(); // put comments to see what happens
		
		
	}
	if(selection==2) // drawing rectangle
	{
			
		sxhma=2;
		glutPostRedisplay();
	}
}



int main(int argc, char **argv)
{
	// initialize toolkit
	glutInit(&argc, argv);
	// set display mode
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
	// set window size
	glutInitWindowSize (screenWidth, screenHeight);
	// set window initial position
	glutInitWindowPosition(1,1);
	// creates a window
	glutCreateWindow ("Dhmiourgia Menu");
	// registers a redraw function, this function is called whenever 
	// the system determines that the window should be redrawn.
	// This first happens when the window is first opened.
	glutDisplayFunc(myDisplay);
	// registers a keyboard handler
	glutKeyboardFunc(keyEvent);
	glutMouseFunc(myMouse);
	// menu creation
	menu = glutCreateMenu(myMenu);
	glutAddMenuEntry("Grammh",1);
	

	glutAddMenuEntry("Orthogwnio parallhlogrammo",2);
	
	// register menu to right mouse button
	glutAttachMenu(GLUT_RIGHT_BUTTON);

	//Initializations
	myInit();

	// perpetual ever processing loop
	glutMainLoop();

	return 0;
}

